// FindFile.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#define _WIN32_WINNT 0x0400
#include <windows.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
  WIN32_FIND_DATA FindFileData;
  HANDLE hFind;

  SetFileApisToOEM();

  hFind = FindFirstFile("C:\\windows\\*.*", &FindFileData);
  if (hFind == INVALID_HANDLE_VALUE) 
  {
    printf ("Invalid File Handle. GetLastError reports %d\n", GetLastError ());
    return 1;
  } 
  else 
  {
	  do
	  {
		  printf ("%s [%s]\n", FindFileData.cFileName,FindFileData.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY?"Folder":"File");
	  }
	  while(FindNextFile(hFind,&FindFileData));
	  FindClose(hFind);
  }
  return 0;
}