// Lock.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>

int _tmain(int argc, _TCHAR* argv[])
{
	int offset;

	if(argc!=2) 
		offset=10;
	else
		offset=atoi(argv[1]);

    HANDLE in=CreateFile("test1.bin",GENERIC_WRITE,0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
	if(in!=INVALID_HANDLE_VALUE) 
	{
        for(int i=0;i<100;i++)
		{
			DWORD BytesWritten;
			if(WriteFile(in,&i,sizeof(int),&BytesWritten,NULL)==0||BytesWritten!=sizeof(int))
			{
				CloseHandle(in);
				return 2;
			}
		}
		CloseHandle(in);
	}
	else
	{
		DWORD l = GetLastError();
		if(GetLastError()!=ERROR_FILE_EXISTS)
			return 1;
	}

	HANDLE in2=CreateFile("test1.bin",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(in2==INVALID_HANDLE_VALUE) return 3;
	BOOL ok = LockFile(in2,(offset-1)*sizeof(int),0,10*sizeof(int),0);
	if(ok==0||ok==NULL)
		printf("Locking failed\n");
	else
	{
		printf("Locking successfull\n");
		Sleep(10000);
	}
	CloseHandle(in2);

	return 0;
}

