// Lock.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>

int _tmain(int argc, _TCHAR* argv[])
{

	// CreateFile if does not exist
	HANDLE in=CreateFile("test1.bin",GENERIC_WRITE,0, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);
	if(in!=INVALID_HANDLE_VALUE) 
	{
        for(int i=0;i<100;i++)
		{
			DWORD BytesWritten;
			if(WriteFile(in,&i,sizeof(int),&BytesWritten,NULL)==0||BytesWritten!=sizeof(int))
			{
				CloseHandle(in);
				return 2;
			}
		}
		CloseHandle(in);
	}
	else
	{
		DWORD l = GetLastError();
		if(GetLastError()!=ERROR_FILE_EXISTS)
			return 1;
	}

	HANDLE in2=CreateFile("test1.bin",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(in2==INVALID_HANDLE_VALUE) return 3;

	HANDLE hMap = CreateFileMapping(in2,NULL,PAGE_READWRITE,0,100*sizeof(int),NULL);
	int *array = (int*)MapViewOfFile(hMap,FILE_MAP_ALL_ACCESS,0,0, 100*sizeof(int));

	for(int i=0;i<100;i++)
	{
		printf("%i\n",array[i]);
		array[i]+=10;
	}
	UnmapViewOfFile(array);
	CloseHandle(in2);

	return 0;
}

