// WinFile.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#define  _WIN32_WINNT 0x0500
#include <windows.h>

DWORD CALLBACK CallBackCopyRoutine(LARGE_INTEGER TotalFileSize,
  LARGE_INTEGER TotalBytesTransferred,
  LARGE_INTEGER StreamSize,
  LARGE_INTEGER StreamBytesTransferred,
  DWORD dwStreamNumber,
  DWORD dwCallbackReason,
  HANDLE hSourceFile,
  HANDLE hDestinationFile,
  LPVOID lpData
)
{
	printf("*");
	return PROGRESS_CONTINUE;
}

int _tmain(int argc, _TCHAR* argv[])
{
	// 1. Copy using CopyFileEx
    BOOL ok = CopyFileEx("input","output",CallBackCopyRoutine,NULL,NULL,0);
	if(!ok) return 1;

	// 2. Copy using ReadFile & WriteFile
	char buffer[10240];
	HANDLE in=CreateFile("input",GENERIC_READ,FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(in==INVALID_HANDLE_VALUE) return 2;
	HANDLE out = CreateFile("output2",GENERIC_WRITE,0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if(out==INVALID_HANDLE_VALUE) 
	{
		CloseHandle(in);
		return 3;
	}

	printf("\n\n");
	DWORD BytesRead, BytesWritten;
	while(ReadFile(in,buffer,sizeof(buffer),&BytesRead,NULL)!=0 && BytesRead>0)
	{
		if(WriteFile(out,buffer,BytesRead,&BytesWritten,NULL)==0||BytesWritten!=BytesRead)
		{
			CloseHandle(in); CloseHandle(out); return 4;
		}
		printf("#");

	}

	CloseHandle(in);
	CloseHandle(out);

	// 3. Create hard link
	BOOL ok2 = CreateHardLink("output3","input",NULL);
	
	return 0;
}

