// Win_aio.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>

int global_completed=0;

VOID CALLBACK IOFinished(DWORD dwErrorCode,DWORD dwNumberOfBytesTransfered,LPOVERLAPPED lpOverlapped)
{
	global_completed++;
	printf("IO Finished for offset: %i\n",lpOverlapped->Offset);
}

int _tmain(int argc, _TCHAR* argv[])
{
    HANDLE hFile;
    hFile=CreateFile("input",GENERIC_READ, 0, NULL,OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,NULL);
	if (hFile==INVALID_HANDLE_VALUE) return 1;
	
	DWORD FileSize = GetFileSize(hFile,NULL);
	char *buffer = (char*)malloc(FileSize);
	if(!buffer) 
	{
		CloseHandle(hFile);
		return 2;
	}
	
	DWORD ToRead=0;
	int submitted=0;
	global_completed=0;
	do
	{
		OVERLAPPED *ol;
		ol=(OVERLAPPED*)malloc(sizeof(OVERLAPPED));
		memset(ol,0,sizeof(OVERLAPPED));
		ol->Offset=ToRead; ol->OffsetHigh=0;
		if(!ReadFileEx(hFile,buffer+ToRead,min(FileSize/10,FileSize-ToRead),ol,IOFinished))
		{
			printf("ReadFileEx error!\n");
			CloseHandle(hFile);
			return 4;
		}
		ToRead+=min(FileSize/10,FileSize-ToRead);
		printf("Submitted for offset: %i\n",ol->Offset);
		submitted++;
	}while(ToRead<FileSize);

	int x=0;
	do{
        DWORD res = SleepEx(1, TRUE);
		if(res == WAIT_IO_COMPLETION )
			printf("W\n");
		x++;
	}while(global_completed<submitted);
	printf("X: %i\n",x);
		
		
	CloseHandle(hFile);
	printf("All finished, press any key to continue ...\n");

	getchar();
	return 0;
}

